lorom
;This first part creates the new PLM for the boostball so that springball doesn't have to be bundled in with high jump
;----------------------------------------------------
org $84F040				;Boost ball item header
DW $EE64
DW Main
Main: 						 ;main plm code
DW $8764 : DW $9100					;gfx location so you can find and change them = 9100 in bank 89
DB $00,$00,$00,$00				
DB $00,$00,$00,$00				
DW $887C : DW ++				;end pointer
DW $8A24 : DW + 				;touch ai	
DW $86C1 : DW $DF89					
-
DW $E04F : DW $E067					
DW $8724 : DW -				;animation loop 
+
DW $8899						
DW $8BDD : DB $02				
DW $88F3 : DW $0040 : DB $1E 		;which item bit it changes and which message box it uses
++
DW $8724 : DW $DFA9

org $858250				;repointing the message box table to allow the boost ball to have it's own entry seperate from the other items
JSR ($9662,x)
org $858254				
JSR ($9660,x)
org $8582F1
LDA $9664,x : STA $00 : LDA $966A,x

org $859660				;index of message boxes
DW $8436,$8289,$877F : DW $83C5,$825A,$87BF : DW $83C5,$825A,$88BF : DW $83C5,$825A,$89BF
DW $83C5,$825A,$8ABF : DW $83CC,$825A,$8BBF : DW $8436,$8289,$8CBF : DW $8436,$8289,$8CFF
DW $8436,$8289,$8D3F : DW $8436,$8289,$8D7F : DW $8436,$8289,$8DBF : DW $8436,$8289,$8DFF
DW $83CC,$825A,$8E3F : DW $8436,$8289,$8F3F : DW $8436,$8289,$8F7F : DW $8436,$8289,$8FBF
DW $8436,$8289,$8FFF : DW $8436,$8289,$903F : DW $83C5,$825A,$907F : DW $8436,$8289,$917F
DW $8436,$8289,$923F : DW $8436,$8289,$92FF : DW $8441,$8289,$93BF : DW $8436,$8289,$94BF
DW $8436,$8289,$94FF : DW $8436,$8289,$953F : DW $8436,$8289,$957F : DW $8441,$8289,$93BF
DW $8436,$8289,$94BF : DW $8436,$8289,Boostball	
DW $0000,$012A,$978A,$012C,$012C,$012C,$0000,$0000,$0000,$0000,$0000,$0000,$0120,$0000,$0000,$0000		
DW $0000,$0000,$012A,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000	
Boostball:				;Boost ball message box words
DW $000E,$000E,$000E,$000E,$000E,$000E,$284E,$284E,$284E,$284E 
DW $284E,$28E1,$28EE,$28EE,$28F2,$28F3,$284E,$28E1,$28E0,$28EB,$28EB 
DW $284E,$284E,$284E,$284E,$000E,$000E,$000E,$000E,$000E,$000E,$000E
;----------------------------------------------------

!fullcharge = #$0020		;This is the amount of frames the run button must be held before the boost is fully charged.
!run = $09B6
!chargesfx = #$0003		;Values for sound effects: while charging, while fully charged, and when boosting respectively.
!donesfx = #$000B
!boostsfx = #$0034

!boostlength = #$0030		;distance of the boost relating to speed
!boost3q = #$0015			;When t is the amount of time her boost lasts, t = d / v  
!boosthalf = #$0010  
!boost1q = #$0005			;(v is her speed and d is her distance, that being the length of the boost)

!fullspeed = #$0007		;speed relating to the distance of the boost
!3qspeed = #$0005		
!halfspeed = #$0004
!1qspeed = #$0003

!fulltimer = #$0004	;This value controls how quickly Samus will lose her boost of speed. (x frames/1 decrement of speed value) 
!jump = #$0006			;max v.speed to reach in pixels
!air = #$00FF			;max v.speed to reach in subpixels

!charge = $1F60			;Important addresses and a couple pointers, don't change these unless you need to repoint the timers
!buttons = $8B
!nofx = #$0001
!sfx = $809143
!boossfx = $8090C1
!boosttimer = $1F62
!speed = $0B42
!timer = $1F64
!height = $0B2E
!heightminor = $0B2C

org $90980D	: JSR Part4		;secondary hijack point.
org $90ECB6	: JSR $F670			;main hijack point.
org $90F670						;main block of code.
	JSR Part1 : JSR Part2 : JSR Part3
	LDA $09A2 : RTS
Part1:
	LDA $09A2 : BIT #$0040 : BEQ + : LDA $0B00 : CMP #$0007 : BNE +					;check for the item, if so check if morphed. 
	LDA !charge : CMP !fullcharge : BEQ Fullycharged : LDA !buttons : BIT !run : BEQ ++		;is the charge full? If not are you holding run? if so inc the charge
	INC !charge
	LDA !chargesfx : JSL !sfx : LDA $7EC186 : CMP #$294F : BEQ $06			;if it's at the max palette, don't do anything, otherwise JSR to palette change
	LDX #$9C40 : JSR Palettechange : RTS				;load the location of the palette into x for the MVN at the JSR
	+		
	LDA !charge : BNE $01 : RTS				;Checks if Samus doesn't have the item, or unmorphed while charging/holding a charge to stop fx.
	++
	STZ !charge : LDA $7EC186 : CMP #$1405 : BEQ +		;Is the palette correct? If not load the new palette and change it
	LDX #$9CA0 : JSR Palettechange
	+
	LDA #$0001 : JSL $809139 : RTS							;otherwise play the sound and end
	
	Fullycharged:
	LDA !buttons : BIT !run : BNE + : STZ !charge : LDX #$9CA0 : JSR Palettechange		;Charge is full, are you still holding it? If not fix the palette
	LDA !boostsfx : JSL !boossfx : LDA $0B36 : BEQ $01 : RTS  ;Play the boost sound, load verticle movement status, if she is on the ground, 
	LDA !boostlength : STA !boosttimer : RTS					;then it's time to boost samus, so load the length to boost, and store it to the boost timer
	+
	LDA $7EC186 : CMP #$1615 : BEQ $06 : LDX #$9C60 : JSR Palettechange	;if you are still holding the charge, check her palette and change if need be
	LDA !donesfx : JSL !sfx : RTS										;otherwise load the sound and end

	Palettechange:										;The code that normally does this is in another bank and is meant to be JSRed to, so I had to copy.
	PHB : STX $12 : LDA $0A74 : XBA : REP #$01		;push the bank, store the loaded palette to 12, load samus palette index, do some math
	ADC $12 : TAX : LDA #$001F : LDY #$C180 : MVN $9B7E		;add your palette to the index of which palette samus is using currently
	PLB : RTS													;Basically cycles her palette depending on which you load for her (in this case shinespark)
	
Part2:
	LDA $09A2 : BIT #$0040 : BEQ + : LDA $0B00 : CMP #$0007 : BNE +		;do you have the item and are morphed?
	LDA !height : CMP #$0007 : BMI +				;if her speed is over #$0006,
	LDA !jump : STA !height : LDA !air : STA !heightminor	;then adjust her pixel and subpixel V.speed to be #$0006
	+ : RTS		
	
Part3:
	LDA !boosttimer : BNE $01 : RTS							;the velocity is proportional to the distance (like IRL physics hehehe)
	CMP !boostlength : BPL + : CMP !boost3q : BPL ++		;if it's at full length, give it full speed, if it's at half, give half, etc.
	CMP !boosthalf : BPL +++ : CMP !boost1q : BPL $10		;btw this optimization (and organization) brought it from 36 lines to 9 :D
	RTS
	+ : LDA !fullspeed : BRA StoreSpeed						;And saved 18 (decimal) bytes
	++ : LDA !3qspeed : BRA StoreSpeed
	+++ : LDA !halfspeed : BRA StoreSpeed
	LDA !1qspeed
	StoreSpeed:
	STA !speed : DEC !boosttimer : RTS
	
Part4:
	PHA : LDA $09A2 : BIT #$0040 : BEQ + : LDA $0B00 : CMP #$0007	 ;do you have the item? Morphed? [PHA saves whatever was in A before the JSR]
	BNE + : LDA $0B36 : BEQ Skip : LDA $0DD0 : CMP #$0001 : BNE Skip	 ;Are you on the ground? Collided with a surface?
	+													;if you're on a surface, don't have the item, or aren't morphed,
	PLA : STZ !speed : RTS								;zero samus' forward speed and end	[PLA pulls what PHA saved, and returns it to A]
	Skip:
	LDA !speed : BEQ ++ : LDA $0B36 : BNE ++		;load her forward speed, if it's zero don't change anything, just return, same if she's in the air
	LDA !timer : CMP !fulltimer : BEQ +	;if the timer is full, zero it and lower her forward speed
	INC !timer										;otherwise increase the timer and end [simple loop for slowing samus down]
	+
	STZ !timer : DEC !speed 	
	++
	PLA : RTS					;That's all folks!

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	